package patrones.memento.ej1;

import java.io.ObjectInputStream;

import java.io.File;
import java.io.FileInputStream;
import java.io.ObjectOutputStream;
import java.io.FileOutputStream;

public class MementoHandler {
	public static final String ID_FILE = "memento.txt";
	private Memento objMemento = null;

	public Memento getMemento() {
		ObjectInputStream objStream = null;
		FileUtil util = new FileUtil();
		// Clase1 c1=null;
		if (util.isFileExists(ID_FILE)) {
			// read the object from the file
			try {
				objStream = new ObjectInputStream(new FileInputStream(ID_FILE));
				objMemento = (Memento) objStream.readObject();
				objStream.close();
			} catch (Exception e) {
				System.out.println("Error Reading Memento " + e.getMessage());
				System.exit(1);
			}
			// delete the old memento
			util.deleteFile(ID_FILE);
		}
		return objMemento;
	}

	public void setMemento(Memento memento) {
		ObjectOutputStream objStream = null;
		// write the object to the file
		try {
			objStream = new ObjectOutputStream(new FileOutputStream(ID_FILE));
			objStream.writeObject(memento);
			objStream.close();
		} catch (Exception e) {
			System.out.println("Error Writing Memento");
			System.exit(1);
		}
	}
}// end of class
